package com.bonus.common.log.aspect;

import java.util.Collection;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson2.JSONObject;
import com.bonus.common.core.utils.DateUtils;
import com.bonus.common.core.utils.SpringUtils;
import com.bonus.common.core.utils.global.SystemGlobal;
import com.bonus.common.log.annotation.SysLog;
import com.bonus.config.SystemConfig;
import com.bonus.system.api.domain.SysLogsVo;
import org.apache.commons.lang3.ArrayUtils;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.AfterThrowing;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.NamedThreadLocal;
import org.springframework.http.HttpMethod;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;
import org.springframework.validation.BindingResult;
import org.springframework.web.multipart.MultipartFile;
import com.alibaba.fastjson2.JSON;
import com.bonus.common.core.utils.ServletUtils;
import com.bonus.common.core.utils.StringUtils;
import com.bonus.common.core.utils.ip.IpUtils;
import com.bonus.common.log.filter.PropertyPreExcludeFilter;
import com.bonus.common.log.service.AsyncLogService;
import com.bonus.common.security.utils.SecurityUtils;
import com.bonus.common.log.enums.OperaResult;
/**
 * 操作日志记录处理
 *
 * @author bonus
 */
@Aspect
@Component
public class LogAspect
{
    private static final Logger log = LoggerFactory.getLogger(LogAspect.class);

    /** 排除敏感属性字段 */
    public static final String[] EXCLUDE_PROPERTIES = { "password", "oldPassword", "newPassword", "confirmPassword" };

    /** 计算操作消耗时间 */
    private static final ThreadLocal<Long> TIME_THREADLOCAL = new NamedThreadLocal<Long>("Cost Time");

    @Autowired
    private AsyncLogService asyncLogService;

    /**
     * 处理请求前执行
     */
    @Before(value = "@annotation(controllerLog)")
    public void boBefore(JoinPoint joinPoint, SysLog controllerLog)
    {
        TIME_THREADLOCAL.set(System.currentTimeMillis());
    }

    /**
     * 处理完请求后执行
     *
     * @param joinPoint 切点
     */
    @AfterReturning(pointcut = "@annotation(controllerLog)", returning = "jsonResult")
    public void doAfterReturning(JoinPoint joinPoint, SysLog controllerLog, Object jsonResult)
    {
        handleLog(joinPoint, controllerLog, null, jsonResult);
    }

    /**
     * 拦截异常操作
     * @param joinPoint 切点
     * @param e 异常
     */
    @AfterThrowing(value = "@annotation(controllerLog)", throwing = "e")
    public void doAfterThrowing(JoinPoint joinPoint, SysLog controllerLog, Exception e)
    {
        handleLog(joinPoint, controllerLog, e, null);
    }

    protected void handleLog(final JoinPoint joinPoint, SysLog controllerLog, final Exception e, Object jsonResult) {
        try
        {
            // *========数据库日志=========*//
            SysLogsVo sysLogsVo=new SysLogsVo();
            sysLogsVo.setOperTime(DateUtils.getTime());
            String uuid= UUID.randomUUID().toString().replace("-","").toUpperCase();
            sysLogsVo.setLogId(uuid);
            if(jsonResult!=null){
                String result = JSON.toJSONString(jsonResult);
                JSONObject jsonObject = JSON.parseObject(result);
                 String code= jsonObject.getString("code");
                 if (SystemGlobal.SUCCESS_CODE_STR.contains(code)){
                     sysLogsVo.setResult(OperaResult.SUCCESS);
                     sysLogsVo.setFailureReason("操作成功");
                 }else{
                     sysLogsVo.setFailureReason(jsonObject.getString("msg"));
                     sysLogsVo.setResult(OperaResult.FAIL);
                 }
            }else{
                //void->无参数返回的
                sysLogsVo.setResult(OperaResult.SUCCESS);
                sysLogsVo.setFailureReason("操作成功");
            }
            //操作模块及路径
            sysLogsVo.setModel(controllerLog.module());
            sysLogsVo.setOperType(controllerLog.businessType());
            sysLogsVo.setLogType(controllerLog.logType());
            if(StringUtils.isEmpty(controllerLog.details())){
                sysLogsVo.setOperateDetail("进行了数据的"+controllerLog.businessType());
            }else{
                sysLogsVo.setOperateDetail(controllerLog.details());
            }

            sysLogsVo.setIp(IpUtils.getIpAddr());
            // 设置方法名称
            String className = joinPoint.getTarget().getClass().getName();
            String methodName = joinPoint.getSignature().getName();
            //方法
            sysLogsVo.setMethod(className + "." + methodName + "()");
            //请求方法
            sysLogsVo.setMethodType(ServletUtils.getRequest().getMethod());
            // 请求的地址
            String username = SecurityUtils.getUsername();
            if (StringUtils.isNotBlank(username)) {
                sysLogsVo.setOperaUserName(username);
            }
            Long userId = SecurityUtils.getUserId();
            if (userId!=null && userId!=0L) {
                sysLogsVo.setUserId(userId.toString());
            }
            sysLogsVo.setOperUri(StringUtils.substring(ServletUtils.getRequest().getRequestURI(), 0, 255));
            sysLogsVo.setTimes(System.currentTimeMillis() - TIME_THREADLOCAL.get()+"");

            // 处理设置注解上的参数
            getControllerMethodDescription(joinPoint, controllerLog, sysLogsVo, jsonResult);
            // 保存数据库
            asyncLogService.addLogs(sysLogsVo);
        }
        catch (Exception exp)
        {
            // 记录本地异常日志
            log.error("异常信息:{}", exp.getMessage());
            exp.printStackTrace();
        }
        finally
        {
            TIME_THREADLOCAL.remove();
        }
    }

    /**
     * 获取注解中对方法的描述信息 用于Controller层注解
     *
     * @param log 日志
     * @param sysLogsVo 操作日志
     * @throws Exception
     */
    public void getControllerMethodDescription(JoinPoint joinPoint, SysLog log, SysLogsVo sysLogsVo, Object jsonResult) throws Exception
    {
        // 设置action动作
        // 设置标题
        sysLogsVo.setTitle(log.title());
        // 是否需要保存request，参数和值
        if (log.isSaveRequestData())
        {
            // 获取参数的信息，传入到数据库中。
            setRequestValue(joinPoint, sysLogsVo, log.excludeParamNames());
        }
        // 是否需要保存response，参数和值
        if (log.isSaveResponseData() && StringUtils.isNotNull(jsonResult))
        {
            sysLogsVo.setResultData(StringUtils.substring(JSON.toJSONString(jsonResult), 0, 3000));
        }
    }

    /**
     * 获取请求的参数，放到log中
     *
     * @param operLog 操作日志
     * @throws Exception 异常
     */
    private void setRequestValue(JoinPoint joinPoint, SysLogsVo operLog, String[] excludeParamNames) throws Exception
    {
        String requestMethod = operLog.getMethod();
        Map<?, ?> paramsMap = ServletUtils.getParamMap(ServletUtils.getRequest());
        boolean bResult = HttpMethod.PUT.name().equals(requestMethod) || HttpMethod.POST.name().equals(requestMethod);
        if (StringUtils.isEmpty(paramsMap) && bResult)
        {
            String params = argsArrayToString(joinPoint.getArgs(), excludeParamNames);
            operLog.setParams(StringUtils.substring(params, 0, 2000));
        }
        else {
            operLog.setParams(StringUtils.substring(JSON.toJSONString(paramsMap, excludePropertyPreFilter(excludeParamNames)), 0, 2000));
        }
    }

    /**
     * 参数拼装
     */
    private String argsArrayToString(Object[] paramsArray, String[] excludeParamNames)
    {
        String params = "";
        if (paramsArray != null && paramsArray.length > 0)
        {
            for (Object o : paramsArray)
            {
                if (StringUtils.isNotNull(o) && !isFilterObject(o))
                {
                    try
                    {
                        String jsonObj = JSON.toJSONString(o, excludePropertyPreFilter(excludeParamNames));
                        params += jsonObj.toString() + " ";
                    }
                    catch (Exception e)
                    {
                    }
                }
            }
        }
        return params.trim();
    }

    /**
     * 忽略敏感属性
     */
    public PropertyPreExcludeFilter excludePropertyPreFilter(String[] excludeParamNames)
    {
        return new PropertyPreExcludeFilter().addExcludes(ArrayUtils.addAll(EXCLUDE_PROPERTIES, excludeParamNames));
    }

    /**
     * 判断是否需要过滤的对象。
     *
     * @param o 对象信息。
     * @return 如果是需要过滤的对象，则返回true；否则返回false。
     */
    @SuppressWarnings("rawtypes")
    public boolean isFilterObject(final Object o)
    {
        Class<?> clazz = o.getClass();
        if (clazz.isArray())
        {
            return clazz.getComponentType().isAssignableFrom(MultipartFile.class);
        }
        else if (Collection.class.isAssignableFrom(clazz))
        {
            Collection collection = (Collection) o;
            for (Object value : collection)
            {
                return value instanceof MultipartFile;
            }
        }
        else if (Map.class.isAssignableFrom(clazz))
        {
            Map map = (Map) o;
            for (Object value : map.entrySet())
            {
                Map.Entry entry = (Map.Entry) value;
                return entry.getValue() instanceof MultipartFile;
            }
        }
        return o instanceof MultipartFile || o instanceof HttpServletRequest || o instanceof HttpServletResponse
                || o instanceof BindingResult;
    }

    public static void main(String[] args) {
        String uuid= UUID.randomUUID().toString().replace("-","").toUpperCase();
        System.err.println(uuid);
    }
}
